%declare F=
   % declare
   %  Test=
functor
import
   BizUser at 'BizUser.ozf'
   DataPersistent at 'lib/dataPersistent.ozf'
export
   BizAgtUser
define
   local
      proc {CommitTransaction BizOperation}
	 {DataPersistent.commitTransaction 'testdb' BizOperation}
      end
      proc {AutoCommit BizOperation}
	 {DataPersistent.autoCommit 'testdb' BizOperation}
      end
   in
      class BizAgtUser
	 meth init
	    skip
	 end
	 meth getUser(Id ?R)
	    {AutoCommit {BizUser.getUser Id R}}
	 end
	 meth getLoginUser(Loginname Pw ?R)
	    Rs in
	    {AutoCommit {BizUser.getUsersByLogin Loginname Pw Rs}}
	    if Rs==nil then R=nil
	    else R={Nth Rs 1}
	    end
	 end
	 meth getAllUsers(?R)
	    {AutoCommit {BizUser.getAllUsers R}}
	 end
	 meth addUser(User)
	    {CommitTransaction {BizUser.addUser User}}
	 end
	 meth updateUser(User)
	    {CommitTransaction {BizUser.updateUser User}}
	 end
	 meth deleteUser(UserId)
	    {CommitTransaction {BizUser.deleteUser UserId}}
	 end
      end
   end
end

     %  	local R A Ba in
     %  	   {DataPersistent.startupDatasource}
     % 	   Ba={New BizAgent init}
	   
     % 	   {Browse {Ba getCommodity(2 $)} }
	   
     %  	   {DataPersistent.closeAllDatasources}
     %  	end
     %      end
     % [M]={Module.apply [Test]}


