functor
import
   Station at 'lib/Station.ozf'
   BizAgtBuy at 'bizAgtBuy.ozf'
   BizAgtUser at 'bizAgtUser.ozf'
   SvrAgtUser at 'svrAgtUser.ozf'
   SvrAgtBuy at 'svrAgtBuy.ozf'
   Browser
export
   ClientFunctor
define
% ͻfunctor
   BAUser={Station.newStat BizAgtUser.bizAgtUser init}
   SAUser={Station.newStat SvrAgtUser.svrAgtUser init(BAUser)}
   BABuy={Station.newStat BizAgtBuy.bizAgtBuy init}
   SABuy={Station.newStat SvrAgtBuy.svrAgtBuy init(BABuy)}
   % {Browser.browse hello4}
   % {Delay 1000}
   functor ClientFunctor
   import
      Tk Application Module TkTools Browser
   define
      % try
      % 	 X={SA getClsTest($)} in	 
      % 	 {Browser.browse {{New X init(7 Browser)} get($)}}
      % catch E
      % then {Browser.browse E}
      % end
      
      class LoginUi
	 attr window btnOk btnCancel lblName lblPw enrName enrPw lblPrompt svrAgtUser:SAUser
	 meth init(MainWindow)
	    window:={New Tk.toplevel tkInit(title:'user login')}	   
	    FrmPrompt={New Tk.frame tkInit(parent:@window width:150 height:20)}
	    FrmEntry={New Tk.frame tkInit(parent:@window width:150 height:60)}
	    FrmButton={New Tk.frame tkInit(parent:@window width:150 height:40)}
	 in
	    lblPrompt:={New Tk.label tkInit(parent:FrmPrompt text:'Please input loginname and password:')}
	    {Tk.send pack(@lblPrompt)}
	    
	    lblName:={New Tk.label tkInit(parent:FrmEntry text:'login name:')}
	    lblPw:={New Tk.label tkInit(parent:FrmEntry  text:'password:')}
	    enrName:={New Tk.entry tkInit(parent:FrmEntry bg:wheat width:20)}
	    enrPw:={New Tk.entry tkInit(parent:FrmEntry bg:wheat width:20)}
	    {Tk.batch [grid(row:1 column:1 @lblName sticky:w padx:5 pady:5)
		       grid(row:1 column:2 @enrName sticky:w padx:5 pady:5)
		       grid(row:2 column:1 @lblPw pady:5)
		       grid(row:2 column:2 @enrPw pady:5)
		      ]}
	    
	    btnOk:={New Tk.button tkInit(parent:FrmButton text:'Ok' width:10
					 action:proc {$}
						   try
						      LoginName={@enrName tkReturn(get $)}
						      Pw={@enrPw tkReturn(get $)}
						      User
						   in
						      if LoginName==nil then User=nil
						      else
							 {{@svrAgtUser getBizAgentUser($)} getLoginUser(LoginName Pw User)}
						      end
						      if User\=nil then
							 {Tk.send wm(deiconify MainWindow)}
							 {@window tkClose}
						      else
							 {@lblPrompt tk(configure
									text:'loginname or password is invalid. '
									#'Please enter them again.')}
							 {@enrName tk(delete 0 'end')}
							 {@enrPw tk(delete 0 'end')}
							 {Tk.send focus(@enrName)}
						      end
						   catch _ then skip
						   end
						end)}
	    btnCancel:={New Tk.button tkInit(parent:FrmButton text:'Cancel' width:10
					     action: proc{$}
							{Application.exit 0}
						     end)}
	    {Tk.send pack(@btnOk @btnCancel side:left padx:10 fill:none)}
	    
	    {Tk.send pack(FrmPrompt FrmEntry FrmButton side:top pady:5)}						   
	    {Tk.send focus(@enrName)}
	 end
      end
      
 % ͻ
      class ClientUI 
	 attr loginUi mainWindow menubar mainFrame frameType svrAgtUser:SAUser svrAgtBuy:SABuy
	 meth init
	    mainWindow:={New Tk.toplevel tkInit(title:'main' withdraw:true)}	    
	    menubar:={TkTools.menubar @mainWindow @mainWindow
		      [menubutton(text: 'System' underline:0
				  menu: [command(label: 'Manage user'
						 action: proc {$}
							    if @frameType\='user' then				  
							       {@mainFrame tkClose}
							       mainFrame:={self createFrame('user' $)}
							       {Tk.send pack(@menubar @mainFrame fill:x)}   
							    end
							 end
						 key: alt(a)
						 feature: user)
					 separator
					 command(label: 'Quit'
						 action: proc{$}
							    {Application.exit 0}
							 end
						 key: ctrl(c))]
				  feature: sys)
		       menubutton(text:'Buy' underline:0
				  menu: [command(label: 'Enter'
						 action: proc {$}
							    if @frameType\='buy' then
							       {@mainFrame tkClose}
							       mainFrame:={self createFrame('buy' $)}
							       {Tk.send pack(@menubar @mainFrame fill:x)}
							    end
							 end) % 
					 command(label: 'Turnback'
						 action: proc {$}
							    skip
							 end) % ˻
					]
				  feature:buy)]
		      nil}
	    {@menubar.sys.menu tk(configure tearoff:false)}
	    {@menubar.buy.menu tk(configure tearoff:false)}	     
	 end
	 meth createFrame(FrameType $)
	    if FrameType=='user'
	    then
	       ClsFrame Obj in
	       frameType:='user'
	       ClsFrame={@svrAgtUser getClsFrameUser($)}
	       try
		  Obj={New ClsFrame init(Browser Tk TkTools @mainWindow @svrAgtUser)}
		  {Obj getFrame($)}
	       catch E then {Browser.browse E}
	       end
	    else
	       FrameFunctor M in
	       frameType:='buy'
	       FrameFunctor={@svrAgtBuy getFtrFrameBuy($)}
	       [M]={Module.apply [FrameFunctor]}
	       {{New M.frameBuy init(@mainWindow @svrAgtBuy)} getFrame($)}
	    end	    
	 end
	 meth initFrame
	    mainFrame:={self createFrame('buy' $)}
	    {Tk.send pack(@menubar @mainFrame fill:x)}
	 end
	 meth showLogin
	    loginUi:={New LoginUi init(@mainWindow)}
	 end
      end
      
      local 
	 ClientUi={New ClientUI init}
      in
	 {ClientUi initFrame}
	 {ClientUi showLogin}
      end 
   end
end